
// initialise when document is loaded
$(function() {

	// global error handler
	// http://stackoverflow.com/questions/10197895/ipad-javascript-error-not-helpful?lq=1
	window.onerror = function (error, page, line, chr) {

		tma.log({
			title: "error in window.onerror",
			details: {
				error: error,
				page: page,	//useless
				line: line,	//useless
				chr: chr,	//useless
			}
		});

	};

	var w = $('#init-progress-frame').innerWidth();
	$(tma).on('tmaProgress', function(e, percent, msg) {

		$('#init-progress').width( parseInt( w * percent / 100) );
		$('.splash .init-progress-msg').text(msg);

	});

	$(tma).on('tmaReady', function() {

		//tma.log('tma is ready');

		document.title = "WebControl - " + tma.config.pvrname + ((tma.config.mock) ? ' (mock)' : '');

		if (!tma.initStatus.logos) {

			new jkqAlert({
				title:	tma.i18.error.dialog_title,
				text:	tma.i18.error.logos.init
			}).confirm();

		}

		/**
		 * let modules insert their register tabs
		 */
		tma.call('appendMenuTab');

		$('#head').css({visibility: 'visible'});
		$('#body').css('margin-top', $('#head').outerHeight());

		// startpage by hash or by prefrence?
		var hash =
			window.location.hash.replace(/^#/, '') ||
			tma.localSetting('startpage', 'configpage');

		var moduleCtx = tma.fn.getModuleData( hash );
		if ( (moduleCtx) && !$.isEmptyObject(moduleCtx.module) ) {
			tma.call( 'setPage', ['MainMenu', moduleCtx.module] );
		} else {
			$( 'UL#MainMenu > LI:first' ).click();
		}

	});

	tma.init();

});
