function TmaEpgEvents( events ) {

	// empty default
	var data = {
			timestamp:			"",
			content:			"epg_events",
			count:				0,
			error:				0,
			requested_starttime:"2013/10/13 17:18:00",
			requested_endtime:	"2013/10/13 21:18:00",
			requested_chtype:	0,
			requested_chnum:	0,
			requested_epgsource:"none",
			epgsource:			"none",
			channel:			null,
			event: 			[],
	};

	// apply initial data
	if (events) {

		$.extend(true, data, events);

		if (events.event && $.isArray(events.event)) {

			// sort events by starttime_local
			events.event.sort(function(event1, event2) {

				var start1 = new Date(event1.starttime_local);
				var start2 = new Date(event2.starttime_local);

				return start1.getTime() - start2.getTime();
			});

			// convert events to TmaEpgEvent
			for (var i = 0; i < events.event.length; i++) {
				events.event[i].channel = data.channel;
				data.event[i] = new TmaEpgEvent(events.event[i]);
			}
		}

	}

	/**
	 * TODO: convert to Getters in future
	 */

	this.timestamp =			data.timestamp;
	this.content =				data.content;
	this.count =				data.count;
	this.error =				data.error;
	this.requested_starttime =	data.requested_starttime;
	this.requested_endtime =	data.requested_endtime;
	this.requested_chtype =		data.requested_chtype;
	this.requested_chnum =		data.requested_chnum;
	this.requested_epgsource =	data.requested_epgsource;
	this.epgsource =			data.epgsource;
	this.event =				data.event;
	/** @returns {TmaChannel} */
	this.channel =				data.channel;

	/**
	 * loops through all events
	 *
	 * @param {Function}	callback	callback function will be called for each recording with parameters (nr, event)
	 */
	this.eachEvent = function( callback ) {

		for (var i = 0; i < data.event.length; i++ ) {
			if (callback.apply( data.event[i], [i, data.event[i]]) === false) {
				break;
			}
		}
	};

	/**
	 * @param {String} name
	 * @returns {TmaFavouritesGroup}
	 */
	this.getEvent = function( eventid ) {

		for (var i = 0; i < data.event.length; i++) {
			if (data.event[i].eventid == eventid) {
				return data.event[i];
			}
		}

		return false;

	};

}

function TmaEpgEvent( event ) {

	// empty default
	var data = {
			eventid:			0,
			datastatus:			0,
			runningstatus:		0,
			starttime_local:	"",
			endtime_local:		"",
			timezone:			0,
			duration:			0,
			satindex:			0,
			networkid:			0,
			tsid:				0,
			serviceid:			0,
			svctype:			0,
			svcnum:				0,
			lang:				"",
			parental:			0,
			namelength:			0,
			descriptionlength:	0,
			textlength:			0,
			name:				"",
			description:		"",
			text:				"",
			citid:				0,
			contentidentifier:	0,
			contentidentifier_hex: "00",
			genre_text:			"",
			genre_code:			"00",
			genre_value:		0,
			au_genre:			0,
			sourceflag:			0,
			icechannel:			0,
			channel:			null,
			parental_text:		'',
	};

	// apply initial data
	if (event) $.extend(true, data, event);

	/**
	 * TODO: convert to Getters in future
	 */

	this.eventid =			data.eventid;
	this.datastatus =		data.datastatus;
	this.runningstatus =	data.runningstatus;
	this.starttime_local =	data.starttime_local;
	this.endtime_local =	data.endtime_local;
	this.timezone =			data.timezone;
	this.duration =			data.duration;
	this.satindex =			data.satindex;
	this.networkid =		data.networkid;
	this.tsid =				data.tsid;
	this.serviceid =		data.serviceid;
	this.svctype =			data.svctype;
	this.svcnum =			data.svcnum;
	this.lang =				data.lang;
	this.parental =			data.parental;
	this.namelength =		data.namelength;
	this.descriptionlength= data.descriptionlength;
	this.textlength =		data.textlength;
	this.name =				data.name;
	this.description =		data.description;
	this.text =				data.text;
	this.citid =			data.citid;
	//this.contentidentifier=	data.contentidentifier;
	//this.contentidentifier_hex= data.contentidentifier_hex;
	//this.genre_text =		data.genre_text;
	//this.genre_code =		data.genre_code;
	//this.genre_value =		data.genre_value;
	this.au_genre =			data.au_genre;
	this.sourceflag =		data.sourceflag;
	this.icechannel =		data.icechannel;
	this.parental_text =	data.parental_text;
	/** @returns {TmaChannel} */
	this.channel =			data.channel;

	/**
	 * get the related genre object
	 *
	 * @returns {TmaGenre}
	 */
	this.genre = function() {

		var genre = tma.genres.genre(data.genre_value);

		if ( genre ) {
			return genre;
		} else {
			return new TmaGenre();
		}

	};

}
