function TmaFavourites( favourites ) {

	// empty default
	var data = {
			timestamp:			"",
			content:			"favourites",
			totalgroups:		0,
			groupsize:			0,
			count:				0,
			currentgroup:		"",
			currentgroup_hex:	"",
			groups: 			[],
	};

	// apply initial data
	if (favourites) {

		$.extend(true, data, favourites);

		for (var i = 0; i < favourites.groups.length; i++) {
			data.groups[i] = new TmaFavouritesGroup(favourites.groups[i]);
		}

	}

	/**
	 * TODO: convert to Getters in future
	 */

	this.timestamp =		data.timestamp;
	this.content =			data.content;
	this.totalgroups =		data.totalgroups;
	this.groupsize =		data.groupsize;
	this.count =			data.count;
	this.currentgroup =		data.currentgroup;
	this.currentgroup_hex =	data.currentgroup_hex;
	this.groups =			data.groups;

	/**
	 * get current group name (non-UTF Toppy safe)
	 *
	 * @returns {String}
	 */
	this.getCurrentGroupName = function() {

		return (tma.config.utftoppy || !data.currentgroup_hex) ?
				data.currentgroup
				: tma.decodeHexname(data.currentgroup_hex);

	};

	/**
	 * loops through all groups
	 *
	 * @param {Function}	callback	callback function will be called for each recording with parameters (nr, group)
	 */
	this.eachGroup = function( callback ) {

		for (var i = 0; i < data.groups.length; i++ ) {
			if (callback.apply( data.groups[i], [i, data.groups[i]]) === false) {
				break;
			}
		}
	};

	/**
	 * @param {String} name
	 * @returns {TmaFavouritesGroup}
	 */
	this.getGroup = function( name ) {

		for (var i = 0; i < data.groups.length; i++) {
			if (data.groups[i].name == name) {
				return data.groups[i];
			}
		}

		return false;

	};

}

function TmaFavouritesGroup( group ) {

	// empty default
	var data = {
			name:		"",
			name_hex:	"",
			count:		0,
			services:	[],
	};

	// apply initial data
	if (group) {

		$.extend(true, data, group);

		for (var i = 0; i < group.services.length; i++) {
			data.services[i] = new TmaFavouritesService(group.services[i]);
		}

	}

	/**
	 * TODO: convert to Getters in future
	 */

	this.name =		data.name;
	this.name_hex =	data.name_hex;
	this.count =	data.count;
	this.services =	data.services;

	/**
	 * get group name (non-UTF Toppy safe)
	 *
	 * @returns {String}
	 */
	this.getName = function() {

		return (tma.config.utftoppy || !data.name_hex) ?
				data.name
				: tma.decodeHexname(data.name_hex);

	};

	/**
	 * loops through all services
	 *
	 * @param {Function}	callback	callback function will be called for each recording with parameters (nr, service)
	 */
	this.eachService = function( callback ) {

		for (var i = 0; i < data.services.length; i++ ) {
			if (callback.apply( data.services[i], [i, data.services[i]]) === false) {
				break;
			}
		}
	};

}

function TmaFavouritesService( service ) {

	// empty default
	var data = {
			svctype:	0,
			svcnum:		0,
			lcn:		0,
			logoid:		"",
			chname:		"",
	};

	// apply initial data
	if (service) {

		$.extend(true, data, service);

	}

	/**
	 * TODO: convert to Getters in future
	 */

	this.svctype =	data.svctype;
	this.svcnum =	data.svcnum;
	this.lcn =		data.lcn;
	this.logoid =	data.logoid;
	this.chname =	data.chname;

}