/**
 * encapsulates file object of json response
 *
 * @param {TmaFile}	file
 */
function TmaFile( file ) {

	// empty default status
	var data = {
			name		: "",
			name_hex	: "",
			timestamp	: "",
			size		: 0,
			inode		: 0,
			attr		: 0,
			info		: 0,
			infpresent	: 0,
			tappresent	: 0,
			infdata		: null,
			tap			: null,

			sortdate	: "",
	};

	// apply initial data
	if (file) {

		$.extend(true, data, file);

		// generate a value to sort for date
		if ( (file.attr == 208) && (file.infpresent) && (file.infdata.header.starttime)) {
			data.sortdate = file.infdata.header.starttime;
		} else {
			data.sortdate = file.timestamp ;
		}

		if ( file.tappresent) {
			data.tap = new TmaTap(file.tap);
		}

	}

	/**
	 * TODO: convert to Getters in future
	 */

	this.name		= data.name;
	this.name_hex	= data.name_hex;
	this.timestamp	= data.timestamp;
	this.size		= data.size;
	this.inode		= data.inode;
	this.attr		= data.attr;
	this.info		= data.info;
	this.infpresent	= data.infpresent;
	this.tappresent	= data.tappresent;
	this.infdata	= data.infdata;
	/** @returns {TmaTap} */
	this.tap		= data.tap;

	this.sortdate	= data.sortdate;

	/**
	 * get file name of the file (non-UTF Toppy safe)
	 *
	 * @param {Boolean]	removeExt	remove file extension? (default = false)
	 * @returns {String}
	 */
	this.getName = function(removeExt) {

		/** @returns {String} */
		var name = (tma.config.utftoppy || !this.name_hex) ?
				this.name
				: tma.decodeHexname(this.name_hex);

		if (removeExt) {
			return name.replace(/\.[^.]+$/, '');
		} else {
			return name;
		}

	};

	//this.absolutefilename =	data.absolutefilename;

}
