/**
 * encapsulates running tap-list object of json response
 *
 * @param {TmaTap}	tap
 */
function TmaTaps(taps) {

	var data = {
			count		: (taps.count)		|| 0,
			timestamp	: (taps.timestamp)	|| "",
			content		: (taps.content)	|| "taps",
			tap			: {},
	};

	// apply initial data
	if (taps) {

		if (taps.tap) {
			for (var i = 0; i < taps.tap.length; i++) {
				var tap = new TmaTap(taps.tap[i]);
				data.tap[tap.index] = tap;
			}
		}

	}

	/**
	 * TODO: convert to Getters in future
	 */

	this.count		= data.count;
	this.timestamp	= data.timestamp;
	this.content	= data.content;
	this.tap		= data.tap;

	/**
	 * loops through all taps
	 *
	 * @param {Function}	callback	callback function will be called for each tap with
	 * 									parameters ({Number} tapIndex, {TmaTap} tap)
	 */
	this.eachTap = function( callback ) {

		for (var index in data.tap ) {
			if (callback.apply( data.tap[index], [index, data.tap[index]]) === false) {
				break;
			}
		}
	};

	/**
	 * loops through all taps
	 *
	 * @param {Number}	tapid
	 * @param {String}	fullpath	optional, also compares the filepath of the TAP
	 * @returns {TmaTap}	or false
	 */
	this.find = function( tapid, fullpath ) {

		var result = false;

		/** @param {TmaTap} tap */
		this.eachTap(function(i, tap) {

			if (tap.tapid == tapid) {
				if (
						(!fullpath) ||
						(fullpath == tap.file_name)
				) {
					result = tap;
					return false; // break
				}
			}
		});

		return result;

	};

}
