function TmaTimer(timer) {

	var data = {
			id: 0,

			index: -1,
			tunerindex: 0,
			recmode: 0,
			demuxpath: 0,
			manualrec: 0,
			satindex: 0,
			servicetype: 0,
			reservationtype: 0,
			serviceid: 0,
			lcn: 0,
			logoid: "",
			chname: "",
			satname: "",
			orgnetid: 0,
			duration: 0,
			filename: "",
			filename_hex: "",
			starttime: "",
			endtime: "",
			pmtid: 0,
			isrec: 0,
			nameset: 0,
			epgmarker: 0,
			eventid1: 0,
			eventid2: 0,
			serviceindex: 0,
			analoguetype: 0,
			icetv: 0,
	};

	// apply initial data
	if (timer) {

		$.extend(true, data, timer);
	}

	/**
	 * TODO: convert to Getters in future
	 */

	/**
	 * internal unique id during objects lifecycle
	 */
	this.id	= data.id;

	this.index			= data.index;
	this.tunerindex		= data.tunerindex;
	this.recmode		= data.recmode;
	this.demuxpath		= data.demuxpath;
	this.manualrec		= data.manualrec;
	this.satindex		= data.satindex;
	this.servicetype	= data.servicetype;

	/**
	 * Reservation type
	 * 0: One Time
	 * 1: Daily
	 * 2: Weekends
	 * 3: Weekly
	 * 4: Week Days
	 * 5: Intelligent Record
	 *
	 * @param {Number} set	new value
	 * @returns {Number}
	 */
	this.reservationtype = function(set) {
		if (set !== undefined) {
			if (parseInt(set) < 0 || parseInt(set) > 5) {
				throw 'set timer.reservationtype: value out of range';
			}
			data.reservationtype = parseInt(set);
		} else {
			return data.reservationtype;
		}
	};

	this.serviceid		= data.serviceid;
	this.lcn			= data.lcn;
	this.logoid			= data.logoid;
	this.chname			= data.chname;
	this.satname		= data.satname;
	this.orgnetid		= data.orgnetid;
	this.duration		= data.duration;
	this.filename		= data.filename;
	this.filename_hex	= data.filename_hex;
	this.starttime		= data.starttime;
	this.endtime		= data.endtime;
	this.pmtid			= data.pmtid;
	this.isrec			= data.isrec;
	this.nameset		= data.nameset;
	this.epgmarker		= data.epgmarker;
	this.eventid1		= data.eventid1;
	this.eventid2		= data.eventid2;
	this.serviceindex	= data.serviceindex;
	this.analoguetype	= data.analoguetype;
	this.icetv			= data.icetv;

	/**
	 * file name of this timer (non-UTF Toppy safe)
	 *
	 * @param {Boolean]	removeExt	remove file extension? (default = false)
	 * @returns {String}
	 */
	this.getFilename = function(removeExt) {

		/** @returns {String} */
		var name = (tma.config.utftoppy || !this.filename_hex) ?
				this.filename
				: tma.decodeHexname(this.filename_hex);

		if (removeExt) {
			return name.replace(/\.[^.]+$/, '');
		} else {
			return name;
		}

	};

}
