/**
 * about module
 */
tma.registerModule( aboutpage );
aboutpage.prototype = new tmaModule();
function aboutpage() {

	/**
	 * IMPORTANT: the modules name; equal to directory and script file name
	 */
	this.name = 'aboutpage';

	this.pageGroup = 'config';

	var self = this;

	/**
	 * initialise module
	 */
	this.setup = function() {

		// register tmaFeatures
		tma.fn.addFeature( this, 'appendMenuTab' );

		return this.loadLanguage();

	};

	/**
	 * append tab to menu
	 *
	 * @param {tmaFeature}	f
	 */
	this.appendMenuTab = function( f ) {

		tma.call('addPage', ['MainMenu', this]);

	};

	/**
	 * Display the channels obtained from the PVR in the browser window
	 */
	this.show = function() {

		this.init().done(function() {

			$('#timestamp').hide();

			self.renderAbout();

		});

	};

	/**
	 * this page gets removed, so remove config class
	 */
	this.cleanup = function() {

		$('#timestamp').show();

	};

	this.renderAbout = function () {

		var template = (
			'<div class="about">' +
				'<h1>{i18.menu_caption}</h1>' +
				'<table>' +
					'<tr>' +
						'<td><img src="modules/aboutpage/img/logo.png" class="logo"></td>' +
						'<td>' +
							'<h2>{i18.tap_version}:</h2>' +
							'<p class="tap-version">{data.tap_version}</p>' +
							'<h2>{i18.fe_version}:</h2>' +
							'<p>{data.fe_version} (Build: {data.fe_revision})</p>' +
							'<h2>{i18.authors}:</h2>' +
							'<p>DeltaMikeCharlie (TAP)<br>' +
							'jkIT (Web)' +
							'</p>' +
							'<h2>{i18.website}:</h2>' +
							'<p><a href="http://deltamikecharlie.yolasite.com/#WebControl" target="_blank">http://deltamikecharlie.yolasite.com/#WebControl</a></p>' +
							'<h2>{i18.credits}:</h2>' +
							'<p>Firebird (FBlib, SmartEPG {i18.db_access}),</p>' +
							'<p>Roger-DTL-Stijfs ({i18.dutch_lng}),</p>' +
							'<p><a href="http://jquery.com">jQuery</a>, ' +
								'<a href="http://amplifyjs.com">appendTo</a> (amplify.js), ' +
								'<a href="http://modernizr.com">Modernizr.js</a>, ' +
								'<a href="http://fortawesome.github.io/Font-Awesome">Font Awesome</a>, ' +
								'<a href="https://github.com/necolas/normalize.css">Normalize.css</a>, ' +
								'<a href="http://twitter.github.io/hogan.js/">Hogan.js</a>, ' +
								'<a href="http://www.openjs.com/scripts/events/keyboard_shortcuts/">shortcut.js</a>, ' +
								'<a href="https://github.com/bgrins/spectrum">spectrum.js</a>' +
							'</p>' +
							'<p>{i18.to_users}.</p>' +
						'</td>' +
					'</tr>' +
				'</table>' +
			'</div>'
		).format({
			i18:	this.i18,
			data:	{
				tap_version:	tma.config.tma1ver,
				fe_version:		tma.version,
				fe_revision:	tma.revision(),
			}
		});

		$(template)
		.appendTo('DIV#content')
		.find('A')
		.click(function(e) {
			e.preventDefault();
			window.open(this.href);
		});

		// get TTD version
		tma.getTTDversion().done(function(result) {

			// create javascript date
			var d = result.date.match(/^(\d{4})(\d{2})(\d{2})/);
			var date = new Date( '{1}-{2}-{3}'.format(d) );

			$('DIV.about P.tap-version').after(
					'<p class="isnewer-{isnewer}">{ttdversiontext}:<br>{version} ({date})</p>'.format({
						isnewer: (parseFloat(tma.config.tma1ver) < parseFloat(result.version)),
						ttdversiontext: self.i18.ttdversiontext,
						version: result.version,
						date: tma.date(tma.i18.date_fmt, date),
					})
			);
			//$('DIV.about P.tap-version').append(' (TAPToDate: ' + result.version + ', ' + result.date + ')');
			//alert(parseFloat(tma.config.tma1ver) + '; ' + parseFloat(result.version));
		});

		// benchmark
		//if (benchstart) {
		//	$('DIV.about').append('<p>Benchmark: ' + (Date.now() - benchstart) + '</p>');
		//}

	};

}
