/**
 * Directory selection modul
 */
tma.registerModule( dirselector );
function dirselector() {

	/**
	 * IMPORTANT: the modules name; equal to directory and script file name
	 */
	this.name = 'dirselector';

	var self = this;

	var popup = new jkqWindow();
	popup.width = 300;

	/**
	 * initialize module
	 */
	this.setup = function() {

		// register tmaFeatures
		tma.fn.addFeature( this, 'selectDirectory' );

		return $.Deferred().resolve();

	};

	/**
	 * show directory tree in a window
	 *
	 * @param {tmaFeature}	f
	 * @param {String}		root		tree root
	 * @param {Function}	onSelect	callback function(path), that is called when a directory is selected
	 */
	this.selectDirectory = function(f, root, onSelect) {

		/**
		 * since this contains asynchronous calls, pause the chain
		 * and decide with the result of the call, whether to stop,
		 * or to continue
		 */
		f.pause();

		this.init().done(function() {

			popup.showModal();
			popup.setTitle( self.i18.window_caption );

			tma.apiTreeFiles(root).done(function() {

				var html = '';

				function addDirs(dirs) {

					$.each(dirs, function(nr, dir) {

						html += '<div class="dir_ctx">';
						html += '<div class="dir_name" path="' + dir.path + '/' + dir.name + '">' + dir.name + '</div>';
						html += '<div class="dir_sub">';
						if (dir.dirs.length) addDirs(dir.dirs);
						html += '</div>';
						html += '</div>';

					});

				}

				addDirs(tma.directories);

				popup.container.find('DIV.jkqWindowContent')
				.html(html)
				.on('click', 'DIV.dir_name', function() {

					if (onSelect) {
						onSelect( $(this).attr('path') );
					}
					popup.close();

				});

				popup.adjustPos();

			}).fail(function(xhr, errorType, error) {

				popup.container.find('DIV.jkqWindowContent').html(
						tma.i18.error.ajax.format(errorType, error)
				);

			});

			popup.container.find('DIV.jkqWindowContent').html('<img src="css/img/wait.gif">');
			popup.adjustPos();

			/**
			 * this method handled the feature, so
			 * stop the feature chain
			 * and return this popup instance
			 */
			f.stop(popup);

		});

	};

}
