
/**
 * create a channel-display config element
 *
 * @param {Number}		currentCfg		current config value
 * @param {String}		caption			caption of the settings entry
 * @param {Object}		optionLabels	type: {logo: string caption, text: string caption, both: string caption }
 * @param {String}		target			selector, to access the data table
 * @param {Function}	onCfgChange		callback: function(newCfgValue)
 * @returns {jQueryObject} div.setting
 */
function createChannelConfig(currentCfg, caption, optionLabels, target, onCfgChange) {

	// logo/text
	var $channelSetting = $(
			'<div class="setting">' +
				'<span class="label">' + caption + '</span>' +
				'<input type="radio" name="logotext" value="1" id="logotext1"><label for="logotext1">' + optionLabels.logo + '</label> ' +
				'<input type="radio" name="logotext" value="2" id="logotext2"><label for="logotext2">' + optionLabels.name + '</label> ' +
				'<input type="radio" name="logotext" value="3" id="logotext3"><label for="logotext3">' + optionLabels.both + '</label> ' +
			'</div>'
	);
	$channelSetting.find('INPUT[name="logotext"]').click(function() {


		var channelDisplay = $('DIV#config INPUT[name="logotext"]:checked').val();

		if (onCfgChange) onCfgChange( channelDisplay );

		if (target) {

			$target = $( target );
			if (channelDisplay & 1) {
				$target.find('TD.channel > DIV').show();
			} else {
				$target.find('TD.channel > DIV').hide();
			}
			if (channelDisplay & 2) {
				$target.find('TD.channel > SPAN').show();
			} else {
				$target.find('TD.channel > SPAN').hide();
			}
		}

	}).filter('[value="' +  currentCfg + '"]' ).attr('checked', true);

	return $channelSetting;

}
