
function configInitialiseSettings()
{
	var APIHttp = new XMLHttpRequest();
	
	//Initialise the channels across list
	APIHttp.open( "GET", "/api?function=setting&action=get!key=channelsacross&", false );
	APIHttp.send( null );
	var API = APIHttp.responseText;
	var APIData = JSON.parse(API);
	
	if(APIData.setting_value == "")
	{
		configSetCurrentChannels(document.getElementsByName('channelcount'), 4);  //The default is 4
	}
	else
	{
		configSetCurrentChannels(document.getElementsByName('channelcount'), APIData.setting_value);
	}

	//Initialise the favourites list
	API = "";
	APIHttp.open( "GET", "/api?function=favourites&action=get!", false );
	APIHttp.send(null);
	var API = APIHttp.responseText;
	var APIData = JSON.parse(API);

	var favselect=document.getElementById("favourites");
	
	for (var grp in APIData.groups)
	{
		if(APIData.groups[grp].count !=0) //Only list groups with members
		{
			var option=document.createElement("option");
			option.text=APIData.groups[grp].name + " (" + APIData.groups[grp].count + ")";
			option.id="fav-" + APIData.groups[grp].name;
			option.value=APIData.groups[grp].name;
			option.name="defaultfav";
			favselect.add(option,null);
		}
	}
	
	API = "";
	APIHttp.open( "GET", "/api?function=setting&action=get!key=defaultfavourites&", false );
	APIHttp.send(null);
	var API = APIHttp.responseText;
	var APIData = JSON.parse(API);
	
	if(APIData.setting_value == "")
	{
		//configSetCurrentFav(document.getElementsByName('favourites'), 4);  //The default is 4
		document.getElementById("fav-AllChannels").selected=true;
	}
	else
	{
		//configSetCurrentFav(document.getElementsByName('favourites'), APIData.setting_value);
		document.getElementById("fav-"+APIData.setting_value).selected=true;
	}


	//Initialise the timers filter
	APIHttp.open( "GET", "/api?function=setting&action=get!key=timersfilter&", false );
	APIHttp.send( null );
	var API = APIHttp.responseText;
	var APIData = JSON.parse(API);
	
	if(APIData.setting_value == "")
	{
		configSetCurrentChannels(document.getElementsByName('timersfilter'), 0);  //The default is All
	}
	else
	{
		configSetCurrentChannels(document.getElementsByName('timersfilter'), APIData.setting_value);
	}
	
}

function configSetCurrentChannels(radioObj, newValue)
{
	if(!radioObj) return;
	var radioLength = radioObj.length;
	if(radioLength == undefined)
	{
		radioObj.checked = (radioObj.value == newValue.toString());
		return;
	}
	for(var i = 0; i < radioLength; i++)
	{
		radioObj[i].checked = false;
		if(radioObj[i].value == newValue.toString())
		{
			radioObj[i].checked = true;
		}
	}
}

function configSave()
{
	
	//alert ("Saving channels across");
	var radios = document.getElementsByName('channelcount');

	for (var i = 0, length = radios.length; i < length; i++)
	{
		if (radios[i].checked)
		{
			var APIHttp = new XMLHttpRequest();
			APIHttp.open( "GET", "/api?function=setting&action=set!key=channelsacross&value="+radios[i].value+"&", false );
			APIHttp.send( null );
			var API = APIHttp.responseText;
			var APIData = JSON.parse(API);
			document.getElementById("timestamp").innerHTML= "Setting: \'" + APIData.setting_key + "\' set to \'" + APIData.setting_value + "\' at " + new Date(APIData.timestamp).toLocaleDateString();
			//break;
		}
	}

	//Save Favourites
	//alert ("Saving default favourites group");
	var favlist = document.getElementById('favourites');
	
	//alert(favlist.length.toString());

	var i=0;
	//for (var i = 0, length = favlist.length; i < length; i++)
	for (i = 0; i < favlist.length; i++)
	{
		if (favlist[i].selected)
		{
			//alert(favlist[i].value);
			var APIHttp = new XMLHttpRequest();
			APIHttp.open( "GET", "/api?function=setting&action=set!key=defaultfavourites&value="+favlist[i].value+"&", false );
			APIHttp.send( null );
			var API = APIHttp.responseText;
			var APIData = JSON.parse(API);
			document.getElementById("timestamp").innerHTML= "Setting: \'" + APIData.setting_key + "\' set to \'" + APIData.setting_value + "\' at " + new Date(APIData.timestamp).toLocaleDateString();
			//break;
		}
	}

	//Save timers filter
	var radios = document.getElementsByName('timersfilter');

	for (var i = 0, length = radios.length; i < length; i++)
	{
		if (radios[i].checked)
		{
			var APIHttp = new XMLHttpRequest();
			APIHttp.open( "GET", "/api?function=setting&action=set!key=timersfilter&value="+radios[i].value+"&", false );
			APIHttp.send( null );
			var API = APIHttp.responseText;
			var APIData = JSON.parse(API);
			document.getElementById("timestamp").innerHTML= "Setting: \'" + APIData.setting_key + "\' set to \'" + APIData.setting_value + "\' at " + new Date(APIData.timestamp).toLocaleDateString();
			//break;
			timersFilter = radios[i].value;
		}
	}
	
	
	
}
